local info = ChatTypeInfo["SYSTEM"];
local SName = GetCVar( "realmName" );
local PName = UnitName("player");
local version = "WoWScribe 1.0";
local SavedChatHandler = nil;

WSFirstUse = 0;
WSEnabled = 0;
wowscribe = {};
wowscribe[SName] = {};
WS_Channels = {};

local mTime = GetTime();

function WS_OnLoad()
	this:RegisterEvent("VARIABLES_LOADED");
end

function WS_OnEvent()

	if (event == "VARIABLES_LOADED") then
		if (WSFirstUse == 0) then
		    WS_Channels["CHAT_MSG_EMOTE"] = 1;
		    WS_Channels["CHAT_MSG_TEXT_EMOTE"] = 1;
		    WS_Channels["CHAT_MSG_GUILD"] = 1;
		    WS_Channels["CHAT_MSG_SAY"] = 1;
		    WSFirstUse = 1;
		end
		messageReceived = 0;
		SlashCmdList["WoWScribeCOMMAND"] = WoWScribeSlash;
		SLASH_WoWScribeCOMMAND1 = "/wscribe"; 
		
   -- Hook the chat event handler
        if (ChatFrame_OnEvent ~= SavedChatHandler) then
            SavedChatHandler = ChatFrame_OnEvent;
            ChatFrame_OnEvent = WoWScribeChat_OnEvent;
        end
		WS_Status();
	end
end

function WoWScribeChat_OnEvent(event)

	local channel = event;
	if (WSEnabled == 1) then -- don't bother if it's disabled
		if (event == "CHAT_MSG_CHANNEL" and (GetTime() - mTime > .5)) then
			channel = string.sub(arg4, 1, 1); -- for #ed channels, change the 'event'
			mTime = GetTime(); -- if we don't use the time part, it'll give us 5-7 copies of the same line!
		end

		if (WS_Channels[channel] == 1) then -- only worry about the channels we're logging
			-- get time of message
			hour, minute = GetGameTime(); --time of day 24 hr
			time = string.format('%02d:%02d', hour, minute);
			-- increment number of messages recieved / array index
			messageReceived = messageReceived + 1;

			-- CHAT_MSG_GUILD
			-- arg1 = message
			-- arg2 = sender
			-- arg3 = language
			if (channel == "CHAT_MSG_GUILD") then
				-- add the row to table array
				wowscribe[SName][messageReceived] = string.format('[%s][Guild] %s: %s', time, arg2, arg1);
			elseif (channel == "CHAT_MSG_SAY") then
				-- add the row to table array
				wowscribe[SName][messageReceived] = string.format('[%s] %s says: %s', time, arg2, arg1);
			elseif (channel == "CHAT_MSG_TEXT_EMOTE") then
				-- add the row to table array
				local firsti, lasti, playername, rest = string.find (arg1, "(%w+) (%C*)");
				if (playername == "You") then
					wowscribe[SName][messageReceived] = string.format('[%s] %s %s', time, arg2, rest);
				else 
					wowscribe[SName][messageReceived] = string.format('[%s] %s', time, arg1);
				end
			elseif (channel == "CHAT_MSG_EMOTE") then
				-- add the row to table array
				wowscribe[SName][messageReceived] = string.format('[%s] %s %s', time, arg2, arg1);
			elseif (channel == "CHAT_MSG_PARTY") then
				wowscribe[SName][messageReceived] = string.format('[%s][Party] %s: %s', time, arg2, arg1);
			elseif (channel == "CHAT_MSG_OFFICER") then
				wowscribe[SName][messageReceived] = string.format('[%s][Officer] %s: %s', time, arg2, arg1);
			elseif (channel == "CHAT_MSG_YELL") then
				wowscribe[SName][messageReceived] = string.format('[%s] %s yells: %s', time, arg2, arg1);
			elseif (channel == "CHAT_MSG_WHISPER") then
				wowscribe[SName][messageReceived] = string.format('[%s] %s tells '..PName..': %s', time, arg2, arg1);
			elseif (channel == "CHAT_MSG_WHISPER_INFORM") then
				wowscribe[SName][messageReceived] = string.format('[%s] '..PName..' tells %s: %s', time, arg2, arg1);
			elseif (channel >= "1" and channel <= "9") then
				wowscribe[SName][messageReceived] = string.format('[%s][%s] %s: %s', time, arg4, arg2, arg1);
			end
		end
	end
	
	-- ok, continue
	SavedChatHandler(event);
end

function WoWScribeSlash(msg)
	local tag = string.lower(msg);
	local firsti, lasti, command, channel = string.find (tag, "(%w+) (%w+)");
	-- if there weren't 2, then command will be nil - check for one arg    
    if (command == nil) then
        firsti, lasti, command = string.find(tag, "(%w+)");
    end    

-- respond to commands
	if (command == nil) then
		WS_Message("WoW Scribe - Use /wscribe <start|stop>"); 
	elseif (command == "start") then
		WS_Message(version.." running!");
		WSEnabled = 1;
	elseif (command == "stop") then
		WS_Message(version.." stopped!");
		WSEnabled = 0;
	elseif (command == "add") then -- add a channel
		if (channel == nil) then
			WS_Help();
		elseif (channel == "basic") then
			WS_SetChannel("CHAT_MSG_GUILD", "on");
			WS_SetChannel("CHAT_MSG_SAY", "on");
			WS_SetChannel("CHAT_MSG_EMOTE", "on");
			WS_SetChannel("CHAT_MSG_TEXT_EMOTE", "on");
			WS_Status();
		elseif (channel == "emote") then
			WS_SetChannel("CHAT_MSG_EMOTE", "on");
			WS_SetChannel("CHAT_MSG_TEXT_EMOTE", "on");
			WS_Status();
		elseif (channel == "whisper") then
			WS_SetChannel("CHAT_MSG_WHISPER", "on");
			WS_SetChannel("CHAT_MSG_WHISPER_INFORM", "on");
			WS_Status();
		elseif (channel >= "1" and channel <= "9") then
			WS_SetChannel(channel, "on");
			WS_Status();
		else
			WS_SetChannel("CHAT_MSG_".. string.upper(channel), "on");
			WS_Status();
		end
	elseif (command == "remove") then -- remove a channel
		if (channel == nil) then
			WS_Help();
		elseif (channel == "emote") then
			WS_SetChannel("CHAT_MSG_EMOTE", "off");
			WS_SetChannel("CHAT_MSG_TEXT_EMOTE", "off");
			WS_Message("Emote no longer logged");
			WS_Status();
		elseif (channel == "whisper") then
			WS_SetChannel("CHAT_MSG_WHISPER", "off");
			WS_SetChannel("CHAT_MSG_WHISPER_INFORM", "off");
			WS_Message("Whisper no longer logged");
			WS_Status();
		elseif (channel == "basic") then
			WS_Help();
		elseif (channel == "all") then
			WS_RemoveAll();
			WS_Status();
		elseif (channel >= "1" and channel <= "9") then
			WS_SetChannel(channel, "off");
			WS_Message(channel .. " no longer logged");
			WS_Status();
		else
			WS_SetChannel("CHAT_MSG".. string.upper(channel), "off");
			WS_Message(channel .. " no longer logged");
			WS_Status();
		end
	elseif (command == "status") then
		WS_Status();
	else
		WS_Help(); 
	end
end

function WS_Status()
	if (WSEnabled == 0) then
    	WS_Message(version.." stopped!");
	else
    	WS_Message(version.." running!");
    end
    
	local str = "";
	table.foreach(WS_Channels, function(k,v) if (v == 1) then str = str..WS_MapChannel(k) end end);
	
	if (str == "") then
		str = "+Nothing+";
	end
	
	WS_Message("  Logging "..str);

end

function WS_RemoveAll()
	table.foreach(WS_Channels, function(k,v) WS_SetChannel(k,"off") end);
end

function WS_Message(msg)
	DEFAULT_CHAT_FRAME:AddMessage(msg, info.r, info.g, info.b, info.id);
end

function WS_Help()
	WS_Message("WoW Scribe - Use /wscribe <start|stop|status>"); 
	WS_Message("    /wscribe add <channelname or number>");
	WS_Message("    /wscribe remove <channelname or number>");
	WS_Message("    	add basic  will add guild, say, and emote");
	WS_Message("    	remove all  will remove all");
end

function WS_SetChannel(channel, value)

	if (value == "on") then
		WS_Channels[channel] = 1;
		if (channel ~= "CHAT_MSG_TEXT_EMOTE" and channel ~= "CHAT_MSG_WHISPER_INFORM") then
			WS_Message(WS_MapChannel(channel) .. " being logged");
		end
	else
		WS_Channels[channel] = 0;
	end
end

function WS_MapChannel(channel)
	local str;
	
	if (channel == "CHAT_MSG_GUILD") then 
		str = "Guild "; 
	elseif (channel == "CHAT_MSG_YELL") then
		str = "Yell ";
	elseif (channel == "CHAT_MSG_WHISPER") then
		str = "Whisper ";
	elseif (channel == "CHAT_MSG_EMOTE") then
		str = "Emotes ";
	elseif (channel == "CHAT_MSG_PARTY") then
		str = "Party ";
	elseif (channel == "CHAT_MSG_RAID") then
		str = "Raid ";
	elseif (channel == "CHAT_MSG_SAY") then
		str = "Says ";
	elseif (channel == "CHAT_MSG_OFFICER") then
		str = "Officer ";
	elseif (channel == "CHAT_MSG_TEXT_EMOTE") then
		str = "";
	elseif (channel == "CHAT_MSG_WHISPER_INFORM") then
		str = "";
	else
		str = channel .. " ";
	end

	return str;
end